summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Robby Workman2013-11-29 20:19:10 +0100
committer Robby Workman2013-11-29 20:19:10 +0100
commit29b578cf50211e8c60b52637fe4fb64b732085a0 (patch)
treeed59b9adf4ec85ed9cb19b05517e99d62d2fd8a4 /development
parenta1521ba4207615ec5c4c9e75d4e2153458dae167 (diff)
downloadslackbuilds-29b578cf50211e8c60b52637fe4fb64b732085a0.tar.gz
development/device-tree-compiler: Added (Device Tree Compiler for Flat Device Trees)
This is needed by qemu to build the flat device tree needed for some ARM emulation. Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/device-tree-compiler/README8
-rw-r--r--development/device-tree-compiler/device-tree-compiler.SlackBuild100
-rw-r--r--development/device-tree-compiler/device-tree-compiler.info12
-rw-r--r--development/device-tree-compiler/slack-desc19
4 files changed, 139 insertions, 0 deletions
diff --git a/development/device-tree-compiler/README b/development/device-tree-compiler/README
new file mode 100644
index 0000000000..ae44ee9bcb
--- /dev/null
+++ b/development/device-tree-compiler/README
@@ -0,0 +1,8 @@
+device-tree-compiler (Device Tree Compiler for Flat Device Trees)
+
+Device Tree Compiler, 'dtc', transforms a textual description of
+a device tree ('DTS') into a binary object ('DTB'). DTS is most
+commonly used on embedded platforms. This tool is particularly
+useful for building a DTS-enabled 'U-Boot' binary.
+
+See http://elinux.org/Device_Tree for more information.
diff --git a/development/device-tree-compiler/device-tree-compiler.SlackBuild b/development/device-tree-compiler/device-tree-compiler.SlackBuild
new file mode 100644
index 0000000000..66721bcd93
--- /dev/null
+++ b/development/device-tree-compiler/device-tree-compiler.SlackBuild
@@ -0,0 +1,100 @@
+#!/bin/bash
+
+# Slackware build script for Device Tree Compiler
+
+# Copyright 2012 Stuart Winter <mozes@slackware.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# With tweaks from rworkman to use in SlackBuilds.org tree
+
+PRGNAM=device-tree-compiler
+VERSION=${VERSION:-1.4.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i686 ;;
+ arm*) export ARCH=arm ;;
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION.orig
+tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
+cd $PRGNAM-$VERSION.orig
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Apply Debian patches:
+# Ordinarily I wouldn't just apply them all, but having done a bit of
+# reading, it seems as if it's a good idea -- plus the developers of the Trimslice
+# develop on Ubuntu, so it makes sense to use as similar 'dtc' to them as possible.
+xz -dc $CWD/${PRGNAM}_${VERSION}*diff.xz | patch -p1
+for i in debian/patches/*.patch ; do patch -p1 < $i ; done
+
+make clean
+make CFLAGS="$SLKCFLAGS" PREFIX=/usr LIBDIR=/usr/lib${LIBDIRSUFFIX}
+make install PREFIX=/usr LIBDIR=/usr/lib${LIBDIRSUFFIX} DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/man/man1
+cp -a debian/manpages/*.1 $PKG/usr/man/man1
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ Documentation/manual.txt GPL README.license TODO \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/device-tree-compiler/device-tree-compiler.info b/development/device-tree-compiler/device-tree-compiler.info
new file mode 100644
index 0000000000..c32db53626
--- /dev/null
+++ b/development/device-tree-compiler/device-tree-compiler.info
@@ -0,0 +1,12 @@
+PRGNAM="device-tree-compiler"
+VERSION="1.4.0"
+HOMEPAGE="http://www.jdl.com/software/dtc.git/"
+DOWNLOAD="http://harrier.slackbuilds.org/misc/device-tree-compiler-1.4.0.tar.xz \
+ http://harrier.slackbuilds.org/misc/device-tree-compiler_1.4.0-2.diff.xz"
+MD5SUM="95b013684a9211af45bc478b9c3adab7 \
+ 76170dfaa6d7d035f21657f16a61d065"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Robby Workman"
+EMAIL="rworkman@slackbuilds.org"
diff --git a/development/device-tree-compiler/slack-desc b/development/device-tree-compiler/slack-desc
new file mode 100644
index 0000000000..0981f486bf
--- /dev/null
+++ b/development/device-tree-compiler/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+device-tree-compiler: device-tree-compiler (Device Tree Compiler for Flat Device Trees)
+device-tree-compiler:
+device-tree-compiler: Device Tree Compiler, 'dtc', transforms a textual description of a
+device-tree-compiler: device tree ('DTS') into a binary object ('DTB').
+device-tree-compiler:
+device-tree-compiler: DTS is most commonly used on embedded platforms.
+device-tree-compiler:
+device-tree-compiler: This tool is particularly useful for building a DTS-enabled 'U-Boot'
+device-tree-compiler: binary.
+device-tree-compiler:
+device-tree-compiler: